## openmohaa 0.82.1+dfsg

=== code/Launcher/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(Launcher)

set(LAUNCHER_SOURCES "${CMAKE_SOURCE_DIR}/code/Launcher/launch_main.cpp")

if (WIN32)
    set(LAUNCHER_SOURCES ${LAUNCHER_SOURCES}
    "${CMAKE_SOURCE_DIR}/code/Launcher/launch_win32.cpp"
    "${CMAKE_SOURCE_DIR}/code/sys/win_resource.rc")
else()
    set(LAUNCHER_SOURCES ${LAUNCHER_SOURCES}
    "${CMAKE_SOURCE_DIR}/code/Launcher/launch_linux.cpp")
endif()

function (create_launcher name type)
    if (NOT BUILD_NO_CLIENT)
        add_executable(openmohaa_launcher_${name} ${LAUNCHER_SOURCES})
        target_include_directories(openmohaa_launcher_${name} PUBLIC "../qcommon")
        target_compile_definitions(openmohaa_launcher_${name} PRIVATE NO_RC_MANIFEST=1 TARGET_GAME=${type})
        target_compile_features(openmohaa_launcher_${name} PRIVATE cxx_std_17)
        set_target_properties(openmohaa_launcher_${name} PROPERTIES OUTPUT_NAME "launch_openmohaa_${name}${TARGET_BIN_SUFFIX}")
        set_target_properties(openmohaa_launcher_${name} PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})

        INSTALL(TARGETS openmohaa_launcher_${name} DESTINATION ${CMAKE_INSTALL_BINDIR}/${BIN_INSTALL_SUBDIR})
    endif()

    #add_executable(omohaaded_launcher_${name} ${LAUNCHER_SOURCES})
    #target_include_directories(omohaaded_launcher_${name} PUBLIC "../qcommon")
    #target_compile_definitions(omohaaded_launcher_${name} PRIVATE NO_RC_MANIFEST=1 TARGET_GAME=${type} DEDICATED=1)
    #target_compile_features(omohaaded_launcher_${name} PRIVATE cxx_std_17)
    #set_target_properties(omohaaded_launcher_${name} PROPERTIES OUTPUT_NAME "launch_omohaaded_${name}${TARGET_BIN_SUFFIX}")
    #set_target_properties(omohaaded_launcher_${name} PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
    #
    #INSTALL(TARGETS omohaaded_launcher_${name} DESTINATION ${CMAKE_INSTALL_BINDIR}/${PROJECT_INSTALL_SUBDIR})
endfunction()

create_launcher(base 0)
create_launcher(spearhead 1)
create_launcher(breakthrough 2)

=== code/cgame/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(cgame)

# Shared source files for modules
set(SOURCES_SHARED
	"../qcommon/class.cpp"
	"../qcommon/con_set.cpp"
	"../qcommon/con_timer.cpp"
	"../qcommon/listener.cpp"
	"../qcommon/lz77.cpp"
	"../qcommon/mem_blockalloc.cpp"
	"../qcommon/mem_tempalloc.cpp"
	"../qcommon/q_math.c"
	"../qcommon/q_shared.c"
	"../qcommon/script.cpp"
	"../qcommon/str.cpp"
	"../script/scriptexception.cpp"
	"../script/scriptvariable.cpp"
)

file(GLOB_RECURSE SOURCES_BG "../fgame/bg_misc.cpp" "../fgame/bg_pmove.cpp" "../fgame/bg_slidemove.cpp" "../fgame/bg_voteoptions.cpp")
file(GLOB_RECURSE SOURCES_CGAME "./*.c" "./*.cpp")

add_library(cgame SHARED ${SOURCES_CGAME} ${SOURCES_BG})
target_compile_definitions(cgame PRIVATE CGAME_DLL)
target_compile_features(cgame PUBLIC cxx_nullptr)
target_compile_features(cgame PUBLIC c_variadic_macros)
target_link_libraries(cgame PUBLIC qcommon)

set_target_properties(cgame PROPERTIES PREFIX "")
set_target_properties(cgame PROPERTIES OUTPUT_NAME "cgame${TARGET_BIN_SUFFIX}")

INSTALL(TARGETS cgame DESTINATION ${CMAKE_INSTALL_LIBDIR}/${LIB_INSTALL_SUBDIR})

if(MSVC)
	INSTALL(FILES $<TARGET_PDB_FILE:cgame> DESTINATION ${CMAKE_INSTALL_LIBDIR}/${LIB_INSTALL_SUBDIR} OPTIONAL)
endif()

=== code/client/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(omohclient)

add_subdirectory("../cgame" "./cgame")

file(GLOB SOURCES_CLIENT "./*.c*")
file(GLOB_RECURSE SOURCES_UILIB "../uilib/*.c*")

set(SOURCES_CLIENT ${SOURCES_CLIENT}
	# Gamespy
	"${CMAKE_SOURCE_DIR}/code/gamespy/cl_gamespy.c"
)

# Made as an interface and not static, as static only links used methods
add_library(omohclient INTERFACE)
target_compile_definitions(omohclient INTERFACE APP_MODULE)
target_compile_features(omohclient INTERFACE cxx_nullptr)
target_compile_features(omohclient INTERFACE c_variadic_macros)
target_link_libraries(omohclient INTERFACE omohsdl_client)
target_link_libraries(omohclient INTERFACE gcd)

# Sound stuff
target_compile_definitions(omohclient INTERFACE USE_CODEC_MP3)

if (NOT NO_MODERN_DMA)
	# Use OpenAL
	find_package(OpenAL REQUIRED)

	if (OPENAL_FOUND)
		target_compile_definitions(omohclient INTERFACE USE_OPENAL=1 NO_MODERN_DMA=0)
		if (MSVC)
			target_include_directories(omohclient INTERFACE ${OPENAL_INCLUDE_DIR}/AL)
		else()
			target_include_directories(omohclient INTERFACE ${OPENAL_INCLUDE_DIR})
		endif()

		if(NOT USE_SYSTEM_LIBS)
			target_compile_definitions(omohclient INTERFACE USE_OPENAL_DLOPEN=1)
		else()
			# Link against system OpenAL
			target_link_libraries(omohclient INTERFACE OpenAL::OpenAL)
		endif()
	endif()

	list(FILTER SOURCES_CLIENT EXCLUDE REGEX "./snd_([a-zA-Z0-9_]+)\.c$")
	file(GLOB SOURCES_CLIENT_SND "./snd_*_new.c*" "./snd_codec*.c*")
	list(APPEND SOURCES_CLIENT ${SOURCES_CLIENT_SND})
else()
	#
	# Fallback to old DMA sound system
	#
	message(NOTICE "OpenAL was explicitly disabled - fallback to old SDL sound system")
	target_compile_definitions(omohclient INTERFACE NO_MODERN_DMA=1)
	set(NO_MODERN_DMA TRUE)

	list(FILTER SOURCES_CLIENT EXCLUDE REGEX "./snd_([a-zA-Z0-9_]+)\.cpp$")
	file(GLOB_RECURSE SOURCES_CLIENT_SND "./new/*.c*")
	list(APPEND SOURCES_CLIENT ${SOURCES_CLIENT_SND})
endif()

set(OLD_VALUE ${BUILD_SHARED_LIBS})
set(BUILD_SHARED_LIBS OFF CACHE BOOL "" FORCE)

if(USE_INTERNAL_MAD)
	add_subdirectory("../thirdparty/libmad" "./libmad" EXCLUDE_FROM_ALL)
	target_link_libraries(omohclient INTERFACE mad)
else()
	include(FindPackageHandleStandardArgs)
	find_path(LIBMAD_INCLUDE_DIRS mad.h)
	find_library(LIBMAD_LIBRARIES mad)
	find_package_handle_standard_args(
		LibMad
		DEFAULT_MSG
		LIBMAD_LIBRARIES
		LIBMAD_INCLUDE_DIRS
	)
	target_include_directories(omohclient INTERFACE ${LIBMAD_INCLUDE_DIRS})
	target_link_libraries(omohclient INTERFACE ${LIBMAD_LIBRARIES})
endif()

set(BUILD_SHARED_LIBS ${OLD_VALUE} CACHE BOOL "" FORCE)

target_sources(omohclient INTERFACE ${SOURCES_CLIENT} ${SOURCES_UILIB})

=== code/curl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(curl)

add_library(curldefs INTERFACE)
target_include_directories(curldefs INTERFACE "./")

find_package(CURL)

if (CURL_FOUND)
    target_include_directories(curldefs INTERFACE ${CURL_INCLUDE_DIRS})
    target_compile_definitions(curldefs INTERFACE HAS_LIBCURL=1)
else()
    message(WARNING "CURL is not available, HTTP-based features will not work.")
endif()

=== code/gamespy/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include_directories("./common")
include_directories("./gcdkey")

file(GLOB SRCS_common
	"./common/*.c"
    "./darray.c"
    "./gserver.c"
    "./gserverlist.c"
	"./hashtable.c"
	"./md5c.c"
	"./gutil.c"
)

file(GLOB SRCS_gcdkey
"./gcdkey/*.c"
)

file(GLOB_RECURSE SRCS_ghttp
"./ghttp/*.c"
)

file(GLOB SRCS_GP
"./GP/*.c"
)

file(GLOB_RECURSE SRCS_gstats
"./gstats/*.c"
)

file(GLOB SRCS_natneg
"./natneg/*.c"
)

file(GLOB SRCS_pinger
"./pinger/*.c"
)

file(GLOB SRCS_pt
"./pt/*.c"
)

file(GLOB SRCS_qr2
"./qr2/*.c"
)

file(GLOB SRCS_sake
"./sake/*.c"
)

file(GLOB SRCS_sc
"./sc/*.c"
)

file(GLOB SRCS_serverbrowsing
"./serverbrowsing/*.c"
)

file(GLOB_RECURSE SRCS_webservices
"./webservices/*.c"
)

add_library(gcd_common STATIC ${SRCS_common})
add_library(gcd_key STATIC ${SRCS_gcdkey})
#add_library(gcd_gp STATIC ${SRCS_GP})
#add_library(gcd_gstats STATIC ${SRCS_gstats})
add_library(gcd_natneg STATIC ${SRCS_natneg})
#add_library(gcd_pinger STATIC ${SRCS_pinger})
#add_library(gcd_pt STATIC ${SRCS_pt})
add_library(gcd_qr2 STATIC ${SRCS_qr2})
#add_library(gcd_sake STATIC ${SRCS_sake})
#add_library(gcd_sc STATIC ${SRCS_sc})
#add_library(gcd_serverbrowsing STATIC ${SRCS_serverbrowsing})
#add_library(gcd_webservices STATIC ${SRCS_webservices})
add_library(gcd INTERFACE)

set_property(TARGET gcd_common gcd_key PROPERTY POSITION_INDEPENDENT_CODE ON)

if(UNIX)
	add_definitions(-D_LINUX=1)
endif(UNIX)

set(DEPENDENT_LIBS
	gcd_key
#	gcd_gp
#	gcd_gstats
	gcd_natneg
#	gcd_pinger
#	gcd_pt
	gcd_qr2
#	gcd_sake
#	gcd_sc
#	gcd_serverbrowsing
#	gcd_webservices
)

target_link_libraries(gcd INTERFACE ${DEPENDENT_LIBS})

foreach(LIB ${DEPENDENT_LIBS})
	target_link_libraries(${LIB} PUBLIC gcd_common)
endforeach()

target_link_libraries(gcd_key PRIVATE gcd_qr2)
target_link_libraries(gcd_qr2 PRIVATE gcd_natneg)

=== code/qcommon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(qcommon)

if(${CMAKE_VERSION} VERSION_GREATER "3.12")
	cmake_policy(SET CMP0076 NEW)
endif()

include("./q_version.cmake")

# Shared source files for modules
set(SOURCES_SHARED_UBER
	"${CMAKE_SOURCE_DIR}/code/qcommon/class.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/con_set.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/con_timer.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/delegate.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/lightclass.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/listener.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/lz77.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/mem_blockalloc.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/mem_tempalloc.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/script.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/str.cpp"
	"${CMAKE_SOURCE_DIR}/code/script/scriptexception.cpp"
	"${CMAKE_SOURCE_DIR}/code/script/scriptvariable.cpp"
)

add_library(qcommon_uber INTERFACE)
target_sources(qcommon_uber INTERFACE ${SOURCES_SHARED_UBER})
target_compile_features(qcommon_uber INTERFACE cxx_nullptr)
target_include_directories(qcommon_uber INTERFACE "../qcommon" "../script")

if(DEBUG_MEM_BLOCK)
	target_compile_definitions(qcommon_uber INTERFACE _DEBUG_MEMBLOCK=1)
endif()

set(SOURCES_SHARED
	"${CMAKE_SOURCE_DIR}/code/qcommon/q_math.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/q_shared.c"
)

add_library(qcommon_shared INTERFACE)
target_sources(qcommon_shared INTERFACE ${SOURCES_SHARED})
target_compile_features(qcommon_shared INTERFACE c_variadic_macros)
target_include_directories(qcommon_shared INTERFACE "../qcommon")
target_link_libraries(qcommon_shared INTERFACE qcommon_version)

add_library(qcommon INTERFACE)
target_link_libraries(qcommon INTERFACE qcommon_shared qcommon_uber)

# Source files for standalone executable
set(SOURCES_COMMON
	"${CMAKE_SOURCE_DIR}/code/qcommon/alias.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/bg_compat.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_fencemask.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_load.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_patch.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_polylib.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_terrain.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_test.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_trace.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_trace_lbd.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cm_trace_obfuscation.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cmd.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/common.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/crc.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/cvar.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/files.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/ioapi.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/huffman.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/md4.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/md5.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/memory.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/msg.cpp"
	"${CMAKE_SOURCE_DIR}/code/qcommon/net_chan.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/net_ip.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/q_math.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/q_shared.c"
	"${CMAKE_SOURCE_DIR}/code/qcommon/unzip.c"
	# Gamespy
	"${CMAKE_SOURCE_DIR}/code/gamespy/q_gamespy.c"
)

add_subdirectory("../skeletor" "./skeletor")
add_subdirectory("../tiki" "./tiki")
add_subdirectory("../curl" "./curl")

add_library(qcommon_standalone INTERFACE)
target_sources(qcommon_standalone INTERFACE ${SOURCES_COMMON})
target_compile_definitions(qcommon_standalone INTERFACE APP_MODULE)

if(DEBUG_DROP_ASSERT)
    target_compile_definitions(qcommon_standalone INTERFACE COM_ERROR_DROP_ASSERT)
endif()

target_compile_features(qcommon_standalone INTERFACE cxx_nullptr)
target_compile_features(qcommon_standalone INTERFACE c_variadic_macros)
target_link_libraries(qcommon_standalone INTERFACE omohtiki omohskeletor)

if(USE_INTERNAL_ZLIB)
    set(SOURCES_ZLIB_DIR "../thirdparty/zlib-1.3.1")
	add_library(zlib INTERFACE)

	target_sources(zlib INTERFACE
		# zlib
		"${SOURCES_ZLIB_DIR}/adler32.c"
		"${SOURCES_ZLIB_DIR}/crc32.c"
		"${SOURCES_ZLIB_DIR}/inffast.c"
		"${SOURCES_ZLIB_DIR}/inflate.c"
		"${SOURCES_ZLIB_DIR}/inftrees.c"
		"${SOURCES_ZLIB_DIR}/zutil.c"
	)

	target_include_directories(zlib INTERFACE "${SOURCES_ZLIB_DIR}")
	target_link_libraries(qcommon_standalone INTERFACE zlib)
else()
	find_package(ZLIB REQUIRED)
	target_include_directories(qcommon INTERFACE ${ZLIB_INCLUDE_DIRS})
	target_link_libraries(qcommon_standalone INTERFACE ${ZLIB_LIBRARIES})
endif()

#
# Unit tests
#

enable_testing()

add_executable(test_lz77 tests/test_lz77.cpp lz77.cpp q_shared.c common_light.c)
target_link_libraries(test_lz77 INTERFACE testing)
add_test(NAME test_lz77 COMMAND test_lz77)
set_tests_properties(test_lz77 PROPERTIES TIMEOUT 15)

=== code/renderercommon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(omohrenderer)

file(GLOB_RECURSE SOURCES_RENDERER_COMMON "./*.c" "./*.cpp")

set(SOURCES_RENDERER_COMMON ${SOURCES_RENDERER_COMMON}
	"../tiki/tiki_mesh.cpp"
)

add_library(omohrenderer_common STATIC ${SOURCES_RENDERER_COMMON})
target_include_directories(omohrenderer_common PUBLIC "../sdl" "./")
target_compile_features(omohrenderer_common PUBLIC cxx_nullptr)
target_compile_features(omohrenderer_common PUBLIC c_variadic_macros)
target_link_libraries(omohrenderer_common PUBLIC qcommon_shared)
target_link_libraries(omohrenderer_common PUBLIC omohsdl_gl)
target_compile_definitions(omohrenderer_common PRIVATE USE_INTERNAL_JPEG=1)

# Add JPEG
if(USE_INTERNAL_JPEG)
    set(SOURCES_JPEG_DIR "../thirdparty/jpeg-9f")

    set(SOURCES_JPEG "${SOURCES_JPEG_DIR}/jaricom.c"
    "${SOURCES_JPEG_DIR}/jcapimin.c"
    "${SOURCES_JPEG_DIR}/jcapistd.c"
    "${SOURCES_JPEG_DIR}/jcarith.c"
    "${SOURCES_JPEG_DIR}/jccoefct.c"
    "${SOURCES_JPEG_DIR}/jccolor.c"
    "${SOURCES_JPEG_DIR}/jcdctmgr.c"
    "${SOURCES_JPEG_DIR}/jchuff.c"
    "${SOURCES_JPEG_DIR}/jcinit.c"
    "${SOURCES_JPEG_DIR}/jcmainct.c"
    "${SOURCES_JPEG_DIR}/jcmarker.c"
    "${SOURCES_JPEG_DIR}/jcmaster.c"
    "${SOURCES_JPEG_DIR}/jcomapi.c"
    "${SOURCES_JPEG_DIR}/jcparam.c"
    "${SOURCES_JPEG_DIR}/jcprepct.c"
    "${SOURCES_JPEG_DIR}/jcsample.c"
    "${SOURCES_JPEG_DIR}/jctrans.c"
    "${SOURCES_JPEG_DIR}/jdapimin.c"
    "${SOURCES_JPEG_DIR}/jdapistd.c"
    "${SOURCES_JPEG_DIR}/jdarith.c"
    "${SOURCES_JPEG_DIR}/jdatadst.c"
    "${SOURCES_JPEG_DIR}/jdatasrc.c"
    "${SOURCES_JPEG_DIR}/jdcoefct.c"
    "${SOURCES_JPEG_DIR}/jdcolor.c"
    "${SOURCES_JPEG_DIR}/jddctmgr.c"
    "${SOURCES_JPEG_DIR}/jdhuff.c"
    "${SOURCES_JPEG_DIR}/jdinput.c"
    "${SOURCES_JPEG_DIR}/jdmainct.c"
    "${SOURCES_JPEG_DIR}/jdmarker.c"
    "${SOURCES_JPEG_DIR}/jdmaster.c"
    "${SOURCES_JPEG_DIR}/jdmerge.c"
    "${SOURCES_JPEG_DIR}/jdpostct.c"
    "${SOURCES_JPEG_DIR}/jdsample.c"
    "${SOURCES_JPEG_DIR}/jdtrans.c"
    "${SOURCES_JPEG_DIR}/jerror.c"
    "${SOURCES_JPEG_DIR}/jfdctflt.c"
    "${SOURCES_JPEG_DIR}/jfdctfst.c"
    "${SOURCES_JPEG_DIR}/jfdctint.c"
    "${SOURCES_JPEG_DIR}/jidctflt.c"
    "${SOURCES_JPEG_DIR}/jidctfst.c"
    "${SOURCES_JPEG_DIR}/jidctint.c"
    "${SOURCES_JPEG_DIR}/jmemmgr.c"
    "${SOURCES_JPEG_DIR}/jmemnobs.c"
    "${SOURCES_JPEG_DIR}/jquant1.c"
    "${SOURCES_JPEG_DIR}/jquant2.c"
    "${SOURCES_JPEG_DIR}/jutils.c")

	add_library(jpeg STATIC ${SOURCES_JPEG})
	target_include_directories(jpeg PRIVATE "${SOURCES_JPEG_DIR}")
	target_include_directories(omohrenderer_common PUBLIC "${SOURCES_JPEG_DIR}")
	target_link_libraries(omohrenderer_common PRIVATE jpeg)
	target_compile_definitions(omohrenderer_common PUBLIC USE_INTERNAL_JPEG)
else()
	find_package(JPEG REQUIRED)
	target_include_directories(omohrenderer_common PUBLIC ${JPEG_INCLUDE_DIRS})
	target_link_libraries(omohrenderer_common PRIVATE ${JPEG_LIBRARIES})
endif()

add_subdirectory("../renderergl1" renderergl1)

add_library(omohrenderer INTERFACE)
target_link_libraries(omohrenderer INTERFACE omohrenderergl1)

if (${USE_RENDERER_DLOPEN})
	add_subdirectory("../renderergl2" renderergl2)
	
	target_link_libraries(omohrenderer INTERFACE omohrenderergl2)
endif()

=== code/renderergl1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(omohrenderergl1)

file(GLOB_RECURSE SOURCES_RENDERER "./*.c" "./*.cpp")

if (${USE_RENDERER_DLOPEN})
	add_library(omohrenderergl1 SHARED ${SOURCES_RENDERER})
else()
	add_library(omohrenderergl1 STATIC ${SOURCES_RENDERER})
endif()

target_compile_features(omohrenderergl1 PUBLIC cxx_nullptr)
target_compile_features(omohrenderergl1 PUBLIC c_variadic_macros)
target_link_libraries(omohrenderergl1 PRIVATE omohrenderer_common)

get_target_property(target_type omohrenderergl1 TYPE)
if (target_type STREQUAL "SHARED_LIBRARY")
	target_compile_definitions(omohrenderergl1 PUBLIC USE_RENDERER_DLOPEN=1)
	target_compile_definitions(omohrenderergl1 PRIVATE REF_DLL=1)
endif ()

set_target_properties(omohrenderergl1 PROPERTIES PREFIX "")
set_target_properties(omohrenderergl1 PROPERTIES OUTPUT_NAME "renderer_opengl1${TARGET_BIN_SUFFIX}")

if (target_type STREQUAL "SHARED_LIBRARY")
	INSTALL(TARGETS omohrenderergl1 DESTINATION ${CMAKE_INSTALL_LIBDIR}/${LIB_INSTALL_SUBDIR})

	if(MSVC)
		INSTALL(FILES $<TARGET_PDB_FILE:omohrenderergl1> DESTINATION ${CMAKE_INSTALL_LIBDIR}/${LIB_INSTALL_SUBDIR} OPTIONAL)
	endif()
endif ()

=== code/renderergl2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(omohrenderergl2)

file(GLOB SOURCES_RENDERER "*.c" "*.cpp" "../renderercommon/tr_*.c")
# Remove Quake III old model source
list(REMOVE_ITEM SOURCES_RENDERER "${CMAKE_CURRENT_SOURCE_DIR}/tr_model.c")

include("glsl/shaders.cmake")

if (${USE_RENDERER_DLOPEN})
	add_library(omohrenderergl2 SHARED ${SOURCES_RENDERER} ${SHADER_SRCS})
else()
	add_library(omohrenderergl2 STATIC ${SOURCES_RENDERER} ${SHADER_SRCS})
endif()

target_compile_features(omohrenderergl2 PUBLIC cxx_nullptr)
target_compile_features(omohrenderergl2 PUBLIC c_variadic_macros)
target_link_libraries(omohrenderergl2 PRIVATE omohrenderer_common)

get_target_property(target_type omohrenderergl2 TYPE)
if (target_type STREQUAL "SHARED_LIBRARY")
	target_compile_definitions(omohrenderergl2 PUBLIC USE_RENDERER_DLOPEN=1)
	target_compile_definitions(omohrenderergl2 PRIVATE REF_DLL=1)
endif ()

set_target_properties(omohrenderergl2 PROPERTIES PREFIX "")
set_target_properties(omohrenderergl2 PROPERTIES OUTPUT_NAME "renderer_opengl2${TARGET_BIN_SUFFIX}")

if (target_type STREQUAL "SHARED_LIBRARY")
	INSTALL(TARGETS omohrenderergl2 DESTINATION ${CMAKE_INSTALL_LIBDIR}/${LIB_INSTALL_SUBDIR})

	if(MSVC)
		INSTALL(FILES $<TARGET_PDB_FILE:omohrenderergl2> DESTINATION ${CMAKE_INSTALL_LIBDIR}/${LIB_INSTALL_SUBDIR} OPTIONAL)
	endif()
endif ()

=== code/sdl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(omohsdl)

set(SOURCES_SDL_CLIENT
"./sdl_input.c"
"./sdl_mouse.c"
)

set(SOURCES_SDL_GL
"./sdl_gamma.c"
"./sdl_glimp.c"
)

if (NO_MODERN_DMA)
	list(APPEND SOURCES_SDL "./sdl_snd.c")
endif()

add_library(omohsdl_client STATIC ${SOURCES_SDL_CLIENT})
target_compile_features(omohsdl_client PUBLIC c_variadic_macros)
target_link_libraries(omohsdl_client PRIVATE qcommon qcommon_standalone)

if (NO_MODERN_DMA)
	target_compile_definitions(omohsdl_client PRIVATE NO_MODERN_DMA=1)
endif()

add_library(omohsdl_gl STATIC ${SOURCES_SDL_GL})
target_link_libraries(omohsdl_gl PRIVATE qcommon)

if(${CMAKE_VERSION} VERSION_GREATER "3.11")
	cmake_policy(SET CMP0074 NEW)
endif()

add_library(sdllib INTERFACE)

if(WIN32)
	find_package(SDL2)

	if (SDL2_FOUND)
		string(STRIP "${SDL2_LIBRARIES}" SDL2_LIBRARIES)
		target_include_directories(sdllib INTERFACE ${SDL2_INCLUDE_DIRS})
		target_link_libraries(sdllib INTERFACE ${SDL2_LIBRARIES})
	else()
		message(WARNING "SDL2 not found, falling back to using SDL2 from the source tree")

		target_include_directories(sdllib INTERFACE "../thirdparty/SDL2-2.32.8/include")

		if (MSVC)
			if(CMAKE_SIZEOF_VOID_P EQUAL 8)
				add_library(sdl2 SHARED IMPORTED)
				set_target_properties(sdl2 PROPERTIES
				  IMPORTED_IMPLIB "${CMAKE_SOURCE_DIR}/code/thirdparty/libs/win64/SDL2.lib"
				)

				add_library(sdl2main SHARED IMPORTED)
				set_target_properties(sdl2main PROPERTIES
				  IMPORTED_IMPLIB "${CMAKE_SOURCE_DIR}/code/thirdparty/libs/win64/SDL2main.lib"
				)
			else()
				add_library(sdl2 SHARED IMPORTED)
				set_target_properties(sdl2 PROPERTIES
				  IMPORTED_IMPLIB "${CMAKE_SOURCE_DIR}/code/thirdparty/libs/win32/SDL2.lib"
				)

				add_library(sdl2main SHARED IMPORTED)
				set_target_properties(sdl2main PROPERTIES
				  IMPORTED_IMPLIB "${CMAKE_SOURCE_DIR}/code/thirdparty/libs/win32/SDL2main.lib"
				)
			endif()

			target_link_libraries(sdllib INTERFACE sdl2 sdl2main)
		endif()
	endif()

elseif(UNIX)
	find_package(SDL2 REQUIRED)
	
	if (SDL2_FOUND)
		string(STRIP "${SDL2_LIBRARIES}" SDL2_LIBRARIES)
		target_include_directories(sdllib INTERFACE ${SDL2_INCLUDE_DIRS})
		target_link_libraries(sdllib INTERFACE ${SDL2_LIBRARIES})
	endif()
endif()

target_link_libraries(omohsdl_client PUBLIC sdllib)
target_link_libraries(omohsdl_gl PUBLIC sdllib)

=== code/server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(omohserver)

add_subdirectory("../fgame" "./fgame")

file(GLOB_RECURSE SOURCES_SERVER "./*.c*")

set(SOURCES_SERVER ${SOURCES_SERVER}
	# Gamespy
	"${CMAKE_SOURCE_DIR}/code/gamespy/sv_gamespy.c"
	"${CMAKE_SOURCE_DIR}/code/gamespy/sv_gqueryreporting.c"
)

add_library(omohserver INTERFACE)
target_sources(omohserver INTERFACE ${SOURCES_SERVER})
target_compile_features(omohserver INTERFACE cxx_nullptr)
target_compile_features(omohserver INTERFACE c_variadic_macros)
target_link_libraries(omohserver INTERFACE qcommon qcommon_standalone)
target_link_libraries(omohserver INTERFACE gcd)

=== code/skeletor/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(omohskeletor)

file(GLOB_RECURSE SOURCES_SKEL "./*.c" "./*.cpp")

add_library(omohskeletor STATIC ${SOURCES_SKEL})
target_compile_features(omohskeletor PRIVATE cxx_nullptr)
target_compile_features(omohskeletor PRIVATE c_variadic_macros)
target_link_libraries(omohskeletor PUBLIC qcommon)

=== debian/control ===
Source: openmohaa
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 bison,
 flex,
 libjpeg-dev,
 libmad0-dev,
 libopenal-dev,
 libsdl2-dev,
 pkgconf,
 zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://www.openmohaa.org
Vcs-Browser: https://salsa.debian.org/games-team/openmohaa
Vcs-Git: https://salsa.debian.org/games-team/openmohaa.git

Package: openmohaa
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 openmohaa-common (= ${binary:Version}),
 game-data-packager-runtime (>= 80~),
 mohaa-data | game-data-packager
Description: game engine for "Medal of Honor: Allied Assault"
 Medal of Honor: Allied Assault is a first-person shooter video game
 that simulates infantry combat in the European and North African theaters
 during World War II. It was originally released in 2002.
 .
 OpenMoHAA is a re-implementation, based on ioquake3, that allows playing
 "Medal of Honor: Allied Assault" and its two expansions.
 .
 You will need the original, non-distributable, game data files.
 You can install them by using the game-data-packager tool.

Package: openmohaa-server
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 openmohaa-common (= ${binary:Version}),
 adduser,
 mohaa-data | game-data-packager
Suggests: game-data-packager-runtime (>= 81~)
Description: dedicated server for "Medal of Honor: Allied Assault"
 This package contains a launcher script and systemd unit to run a
 Medal of Honor: Allied Assault server with the openmohaa engine.
 .
 Medal of Honor: Allied Assault is a first-person shooter video game
 that simulates infantry combat in the European and North African theaters
 during World War II. It was originally released in 2002.
 .
 OpenMoHAA is a re-implementation, based on ioquake3, that allows playing
 "Medal of Honor: Allied Assault" and its two expansions.
 .
 You will need the original, non-distributable, game data files.
 You can install them by using the game-data-packager tool.

Package: openmohaa-common
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: game-data-packager
Description: common files for OpenMoHAA
 This package contains files shared by all openmohaa packages.
 .
 It is unnecessary to install this package unless you are installing one
 of the packages that depends on it.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -O0

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_LIBS=ON

override_dh_auto_install:

=== debian/watch ===
version=4

opts="\
pgpmode=none,\
repack,repacksuffix=+dfsg,dversionmangle=s/\+dfsg$//,\
" \
https://github.com/openmoh/openmohaa/tags .*/[vV]?(\d[^\s+]+)\.tar\.gz \
  debian uupdate
